import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A Balloon that can be popped by the clowns.
 * 
 * @author Folkert van Verseveld 
 * @version 0.0.2
 */
public class Balloon  extends AnimatedActor
{
    private static final int count = 4;
    private int row = 0;
    private String deadImages;
    
    public Balloon(String images, String deadImages, int row)  
    {
        super(images, ".png", 2);
        this.deadImages = deadImages;
        this.row = row;
    }
    
    /**
     * Act - do whatever the Balloon wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        if (getX() < 2)
        {
            setLocation(getX() +
                ((MenuWorld) getWorld()).getWorldWidth(), getY());
        }
        setLocation(getX() - 8, getY());
        Clown aClown = (Clown) getOneIntersectingObject(Clown.class);
        if (aClown != null)
        {
            if (aClown.getCanPop())
            {
                getWorld().addObject(new DeadBalloon(deadImages), getX(), getY());
                //aClown.setVSpeed(aClown.getVSpeed() / 2);
                //aClown.setHSpeed((aClown.getX() > getX() ? 2 : -2));
                aClown.setCanPop(false);
                int i = aClown.getX() > getX() ? 4 : -4;
                int j = -1 + Greenfoot.getRandomNumber(2);
                aClown.setLocation(aClown.getX() + i, aClown.getY() + j);
                aClown.setHSpeed(i / 2);
                rowCountSubstract();
                ((MenuWorld) getWorld()).counter.add(2);
                getWorld().removeObject(this);
            }
        }
    }
    
    /**
     * Sets the world row count--
     */
    public void rowCountSubstract()
    {
        MenuWorld currentWorld = ((MenuWorld)getWorld());
        currentWorld.rowCount[row]--;
        currentWorld.checkRow(row);
        // the code below will show how much balloons there are in the row
//        int i = ((MenuWorld)getWorld()).rowCount[row];
//        System.out.println("count of balloons at row " + row + " = " + i);
    }
}
