import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The barrier where the clowns are bouncing on.
 * 
 * @author Folkert van Verseveld 
 * @version 0.0.2
 */
public class Barrier  extends ImagesActor
{
    public Barrier()
    {
        super("images/bouncers/barrier", ".png", 1);
    }
    
    /**
     * Do whatever the Barrier wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        int i, j;
        setLocation(getX() + 4, getY());
        if (getX() > ((MenuWorld)getWorld()).getWorldWidth() - 2)
        {
            setLocation(0, getY());
        }
        Clown clown = (Clown) getOneIntersectingObject(Clown.class);
        if (clown != null && !clown.getDisabled())
        {
            if (clown.getY() + 4 < getY())
            {
                clown.setVSpeed(-2);
                i = (-2 + Greenfoot.getRandomNumber(4));
                clown.setHSpeed(i);
                clown.setLocation(clown.getX() + i, clown.getY() - 2);
            }
            else if (clown.getY() > getY() + 4)
            {
                i = (int) clown.getVSpeed();
                if (i > 0)
                {
                    i = 0;
                }
                j = (-2 + Greenfoot.getRandomNumber(4));
                clown.setVSpeed(2);
                clown.setHSpeed(j);
                clown.setLocation(clown.getX() + j, clown.getY() + 2);
            }
            bounce();
        }
    }
    
    /**
     * Make a 'bounce' sound and animate
     */
    public void bounce()
    {
        Greenfoot.playSound("sounds/bounce.wav");
    }
}
