import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * The seal uses the Beachball.
 * 
 * @author Folkert van Verseveld
 * @version 0.0.2
 */
public class Beachball extends AnimatedActor
{
    private static final float gravitySpeed = 0.5F;
    private float vspeed = 0F;
    public Beachball()
    {
        super("images/acts/beachball-", ".png", 3);
    }
    
    /**
     * Fly to the left. When we hit the edge, disappear.
     */
    public void act() 
    {
        gravity();
        setLocation(getX(), getY() + ((int) vspeed));
        if (getY() > 328)
        {
            vspeed = -8;
        }
        super.act();  // this takes care of the image animation
    }
    
    public void gravity()
    {
        vspeed += gravitySpeed;
        if (vspeed > 12)
        {
            vspeed = 12;
        }
    }
}
