import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The bouncer where the clowns are bouncing on.
 * 
 * @author Folkert van Verseveld 
 * @version 0.0.2
 */
public class Bouncer  extends ImagesActor
{
    private int ellapsedTime = 0;
    public Bouncer()
    {
        super("images/bouncers/bouncer-", ".png", 2);
    }
    
    /**
     * Do whatever the Bouncer wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        Clown clown = (Clown) getOneIntersectingObject(Clown.class);
        if (clown != null && !clown.getDisabled() && ellapsedTime <= 0)
        {
            clown.bounce();
            bounce();
            ((MenuWorld) getWorld()).counter.add(1);
        }
        if (ellapsedTime > 0)
        {
            ellapsedTime++;
        }
        if (ellapsedTime > 30)
        {
            ellapsedTime = 0;
            animate(1);
        }
    }
    
    /**
     * Make a 'bounce' sound and animate
     */
    public void bounce()
    {
        animate(1);
        Greenfoot.playSound("sounds/bounce.wav");
        ellapsedTime += 1;
    }
}
