import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * An class that has images, but he does not animate self instead the
 * AnimatedActor.
 * 
 * @author Folkert van Verseveld
 * @version 0.0.2
 */
public class ImagesActor extends Actor
{
    private GreenfootImage[] images;
    private float currentImage = 0F;
    private int noOfImages;
    
    public ImagesActor(String basename, String suffix, int noOfImages)
    {
        this.noOfImages = noOfImages;
        images = new GreenfootImage[noOfImages];
        for(int i=0; i < noOfImages; i++)
        {
            images[i] = new GreenfootImage(basename + i + suffix);
        }
        setImage(images[((int) currentImage)]);
    }
    
    /**
     * mirror ALL the images horizontally.
     * @param noOfImages total images to mirror horizontally.
     */
    public void imagesMirrorHorizontally()
    {
        for (int i=0; i < noOfImages; i++)
        {
            images[i].mirrorHorizontally();
        }
    }
    
    /**
     * mirror ALL the images vertically.
     * @param noOfImages total images to mirror vertically.
     */
    public void imagesMirrorVertically()
    {
        for (int i=0; i < noOfImages; i++)
        {
            images[i].mirrorVertically();
        }
    }
    
    /**
     * sets currentImage relative with noOfImages.
     * @param noOfImages total images to relative.
     */
    public void animate(float noOfImages)
    {
        currentImage = (currentImage + noOfImages) % images.length;
        setImage(images[((int) currentImage)]);
    }
}
