import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A balloon in the menu that's flying on the screen.
 * 
 * @author Folkert van Verseveld 
 * @version 0.0.2
 */
public class MenuBalloon extends Actor//  extends AnimatedActor
{
    private GreenfootImage[] images;
    protected float currentImage = 0F;
    private float animationSpeed = 0.1F;
    private int noOfImages = 2;
    private static String imageName[] =
    {
        "blue/blue" , "cyan/cyan" , "green/green" , "orange/orange" ,
        "purple/purple" , "red/red", "yellow/yellow", "white/white"
    };
    private static final float gravitySpeed = 0.2F;
    public float vSpeed = 0F;
    public float hSpeed = -4 + Greenfoot.getRandomNumber(8);
    private static final int LEFT = -1;
    private static final int NOMOVE = 0;
    private static final int RIGHT = 1;
    private int direction = NOMOVE;
    private int xscale = 1; // 1 when the sprite draw as original, -1 instead.
    
    public MenuBalloon()
    {
        //super("images/balloons/" + imageName[Greenfoot.getRandomNumber(8)] + "-", ".png", 2);
        String i = imageName[Greenfoot.getRandomNumber(8)];
        images = new GreenfootImage[noOfImages];
        for(int j=0; j < noOfImages; j++)
        {
            images[j] = new GreenfootImage("images/balloons/" + i + "-" + j + ".png");
        }
        setImage(images[((int) currentImage)]);
    }
    
    /**
     * Do whatever the MenuBalloon wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if (hSpeed == 0)
        {
            hSpeed = -4 + Greenfoot.getRandomNumber(8);
        }
        setDirection();
        gravity();
        setLocation(getX() + (int) hSpeed, getY() + (int) vSpeed);
        if (getY() > ((MenuWorld)getWorld()).getWorldHeight() - 8)
        {
            vSpeed = -(8 + Greenfoot.getRandomNumber(6));
        }
        if (getX() > ((MenuWorld)getWorld()).getWorldWidth() - 8)
        {
            setLocation(((MenuWorld)getWorld()).getWorldWidth() - 8, getY());
            hSpeed = -hSpeed;
        }
        if (getX() < 8)
        {
            setLocation(8, getY());
            hSpeed = -hSpeed;
        }
        MenuBalloon mb = (MenuBalloon) getOneIntersectingObject(MenuBalloon.class);
        if (mb != null)
        {
            if (mb.getX() > getX())
            {
                hSpeed = -hSpeed;
                setLocation(getX() - 2, getY());
            }
            if (mb.getX() < getX())
            {
                hSpeed = -hSpeed;
                setLocation(getX() + 2, getY());
            }
            vSpeed = -vSpeed;
        }
        super.act();
    }
    
    public void gravity()
    {
        vSpeed += gravitySpeed;
    }
    
    public void setDirection()
    {
        if (hSpeed < 0)
        {
            direction = LEFT;
            if (xscale == -1)
            {
                xscale = 1;
                imagesMirrorHorizontally();
            }
        }
        else if (hSpeed > 0)
        {
            direction = RIGHT;
            if (xscale == 1)
            {
                xscale = -1;
                imagesMirrorHorizontally();
            }
        }
        else
        {
            direction = NOMOVE;
        }
    }
    
    /**
     * mirror ALL the images horizontally.
     */
    public void imagesMirrorHorizontally()
    {
        for (int i=0; i < noOfImages; i++)
        {
            images[i].mirrorHorizontally();
        }
    }
}
