import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A MenuButton that can be selected. when selected, it runs the
 * 'selectListener'.
 * 
 * @author Folkert van Verseveld 
 * @version 0.0.2
 */
public class MenuButton  extends Actor
{
    GreenfootImage image;
    //dImage = image (to) draw / drawed image
    GreenfootImage dImage = new GreenfootImage("images/title/title-highlights.png");
    private int x;
    private int y;
    private int width;
    private int height;
    private int borderX;
    private int borderY;
    private boolean selected;
    
    /**
     * Initialize the constructor
     */
    public MenuButton(int width, int height,
                      int borderX, int borderY)
    {
        this.width = width;
        this.height = height;
        this.borderX = borderX;
        this.borderY = borderY;
        makeImage();
    }
    
    /**
     * Act - do whatever the MenuButton wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        //System.out.println("getX()="+getX()+", getY()="+getY());
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse != null)
        {
            //System.out.println("Mx="+mouse.getX()+", My="+mouse.getY());
            if (mouse.getX() >= getX() - width / 2 && mouse.getY() >= getY() - height / 2 &&
                mouse.getX() <= getX() + width / 2 && mouse.getY() <= getY() + height / 2)
            {
                selected = true;
                updateImage();
            }
            else
            {
                selected = false;
                updateImage();
            }
        }
        if (Greenfoot.mouseClicked(null))
        {
            if (mouse.getX() >= getX() - width / 2 && mouse.getY() >= getY() - height / 2 &&
                mouse.getX() <= getX() + width / 2 && mouse.getY() <= getY() + height / 2)
            {
                selectListener();
            }
        }
    }
    
    /**
     * Make the menuButton image.
     */
    public void makeImage()
    {
        GreenfootImage image = new GreenfootImage(width, height);
        setImage(image);
        updateImage();
    }
    
    /**
     * Update the image.
     */
    public void updateImage()
    {
        GreenfootImage image = getImage();
        image.clear();
        if (selected)
        {
            image.drawImage(dImage, x - borderX, y - borderY);
        }
        //((MenuWorld)getWorld()).setPaintOrder(Balloon.class, Light.class, MenuButton.class);
    }
    
    /**
     * Runs when selected
     */
    public void selectListener()
    {
        
    }
}
