import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
//import java.util.List;

/**
 * The teeter totter that launces the clowns.
 * 
 * @author Folkert van Verseveld 
 * @version 0.0.2
 */
public class TeeterTotter  extends ImagesActor
{
    private static final int RIGHT = 1;
    private static final int LEFT = -1;
    private static int clownPlace = LEFT;
    private static int worldClownPlace = LEFT;
    private static int teeterTotterPlace = RIGHT - 1;
    private Clown clown;
    private Clown worldClown;
    private static int clownCount = 2;
    private static int clownListenerWait = 2;
    private static int clownCheckWait = 5;
    private static boolean canClownCheck = false;
    private static boolean soundCount = false;
    
    public TeeterTotter(Clown clown, Clown worldClown)
    {
        super("images/teeter-totter/teeter-totter-", ".png", 4);
        this.clown = clown;
        this.worldClown = worldClown;
    }
    
    /**
     * Do whatever the Bouncer wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Follow the mouse
        if (Greenfoot.mouseMoved(null))
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            if (mouse.getX() > 72 && mouse.getX() < 568)
            {
                setLocation(mouse.getX(), getY());
                animate(0.25F);
            }
            else if (mouse.getX() <= 72)
            {
                setLocation(72, getY());
            }
            else if (mouse.getX() >= 568)
            {
                setLocation(568, getY());
            }
            if (clown.getDisabled())
            {
                clownSetLocation();
            }
            if (worldClown.getDisabled())
            {
                worldClownSetLocation();
            }
        }
        
        if (Greenfoot.mouseClicked(null))
        {
            mirrorHorizontal();
        }
        
        if (!canClownCheck)
        {
            clownCheckWait--;
            if (clownCheckWait <= 0)
            {
                clownCheckWait = 5;
                canClownCheck = true;
            }
        }
    }
    
    /**
     * Mirrors the clown(s) on the teeterTotter and the teeterTotter
     * self.
     */
    public void mirrorHorizontal()
    {
        clownPlace = (clownPlace == RIGHT) ? LEFT : RIGHT;
        worldClownPlace = (worldClownPlace == RIGHT) ? LEFT : RIGHT;
        teeterTotterPlace = (teeterTotterPlace == RIGHT) ? LEFT : RIGHT - 1;
        if (clown.getDisabled())
        {
            clown.updateImage();
            clown.setLocation(getX() + 32 * clownPlace,
                              getY() - 12 * teeterTotterPlace);
        }
        if (worldClown.getDisabled())
        {
            worldClown.updateImage();
            worldClown.setLocation(getX() + 32 * worldClownPlace,
                                   getY() - 12 * teeterTotterPlace);
        }
        imagesMirrorHorizontally();
    }
    
    /**
     * Launch one clown from the teeterTotter and sets the other clown on the
     * teeterTotter.
     */
    public void launchClowns()
    {
        if (canClownCheck)
        {
            ((MenuWorld) getWorld()).counter.add(1);
            if (clown.getDisabled())
            {
                mirrorHorizontal();
                worldClown.resetSpeeds();
                worldClown.setDisabled(true);
                worldClownSetLocation();
                clown.setDisabled(false);
                clown.launch(soundCount);
            }
            else
            {
                mirrorHorizontal();
                clown.resetSpeeds();
                clown.setDisabled(true);
                clownSetLocation();
                worldClown.setDisabled(false);
                worldClown.launch(soundCount);
            }
            canClownCheck = false;
            soundCount = (soundCount == true) ? false : true;
        }
    }
    
    /**
     * Sets the clown on the teeterTotter 'location'.
     */
    public void clownSetLocation()
    {
        clown.setLocation(getX() + 32 * clownPlace,
                          getY() - 12 * teeterTotterPlace);
        clown.setImagesTeeterTotter();
        clown.updateImage();
    }
    
    /**
     * Sets the worldClown on the teeterTotter 'location'.
     */
    public void worldClownSetLocation()
    {
        worldClown.setLocation(getX() + 32 * clownPlace,
                          getY() - 12 * teeterTotterPlace);
        worldClown.setImagesTeeterTotter();
        worldClown.updateImage();
    }
}
